
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="13">
<h1>Логирование</h1>
<p>Логирование — это процесс записи данных о работе приложения. Оно позволяет отследить, что и когда происходило в приложении. Без логов сложно понять, из-за чего появляется ошибка, если она возникает периодически и только при определенных условиях. Анализ логов — один из базовых инструментов в работе программистов. Он помогает обнаружить источники многих проблем, отследить различные события. Существуют разные уровни логирования, от максимально подробного до вывода только ключевой информации. В этом задании вам нужно будет реализовать запись логов сервера в файл. Дополнительно в этом домашнем задании мы познакомимся с новым современным шаблонизатором &quot;Thymeleaf&quot;. Чтобы сократить количество кода, в этом задании будем работать не с полным CRUD сущности, а только с его частью.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://guides.hexlet.io/logging/">Логирование</a></li>
<li data-marpit-fragment="2"><a href="https://docs.oracle.com/cd/E57471_01/bigData.100/data_processing_bdd/src/rdp_logging_config.html">Настройка логгера</a></li>
<li data-marpit-fragment="3"><a href="https://www.thymeleaf.org/">Шаблонизатор Thymefeaf</a></li>
<li data-marpit-fragment="4"><a href="https://www.thymeleaf.org/doc/tutorials/3.0/usingthymeleaf.html#creating-and-configuring-the-template-engine">Создание и настройка движка шаблонов Thymeleaf</a></li>
</ul>
<h2>logging.properties</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="5">Допишите файл конфигурации логгера. Настройте логгер таким образом, чтобы логи приложения с уровнем INFO записывались в файл <em>app.log</em> в корне приложения.</li>
</ul>
<h2>src/main/java/exercise/servlet/SessionServlet.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="6">Допишите метод <code>login()</code> таким образом, чтобы при попытке входа пользователя в приложение в файл <em>app.log</em> записывался лог с уровнем INFO. Сообщение должно содержать email пользователя, который входит в приложение. Запись в лог должна происходить как при удачной, так и при неудачной попытке входа.</li>
</ul>
<h2>src/main/java/exercise/LoggerFactory.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="7">Изучите методы класса <code>LoggerFactory</code>. Посмотрите, как происходит настройка и получение экземпляра логгера.</li>
</ul>
<h2>src/main/java/exercise/App.java</h2>
<p>В этом задании шаблонизатор &quot;Thymeleaf&quot; уже подключен к приложению.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="8">Изучите блок импортов и код в методе <code>getApp()</code>, обратите внимание на то, как происходит подключение шаблонизатора к приложению.</li>
</ul>
<h2>src/main/java/exercise/servlet/UsersServlet.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="9">Изучите код обработчиков <code>showUsers()</code>, <code>newUser()</code>, <code>createUser()</code>. Посмотрите, как производится рендеринг указанного шаблона в обработчиках.</li>
</ul>
<h2>src/main/webapp/WEB_INF/templates</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="10">Изучите структуру субдиректорий в директории <em>src/main/webapp/WEB_INF/templates</em>, в которой расположены шаблоны.</li>
<li data-marpit-fragment="11">Изучите файлы шаблонов. Обратите внимание, что общая часть, которая повторяется во всех шаблонах, вынесена в файл <em>application.html</em>.</li>
</ul>
<h2>Самостоятельная работа</h2>
<p>Попробуйте самостоятельно поэксперементировать с шаблонизатором &quot;Thymeleaf&quot;.</p>
<ul>
<li data-marpit-fragment="12">
<p>В файле <em>src/main/webapp/WEB_INF/templates/session/users/new.html</em> реализуйте вывод формы регистрации нового пользователя. В форме должно быть три текстовых поля для ввода имени, фамилии и email пользователя. Если были введены некорректные данные, поля должны быть заполнены введенными данными. Не забывайте использовать классы bootstrap, чтобы страница выглядела более привлекательно.</p>
</li>
<li data-marpit-fragment="13">
<p>В файле <em>scr/test/java/exercise/AppTest.java</em> по аналогии с имеющимися тестами допишите тесты, проверяющий работу страницы регистрации. Чтобы убедится, что всё работает корректно, достаточно будет проверить, что GET-запрос на адрес <em>/users/new</em> возвращает код ответа 200.</p>
</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
